package com.tzld.piaoquan.risk.control.config;

import com.tzld.piaoquan.risk.control.common.enums.ExceptionEnum;
import com.tzld.piaoquan.risk.control.common.exception.CommonException;
import com.tzld.piaoquan.risk.control.model.po.User;

import java.util.Optional;

public class LoginUserContext {
    private final static ThreadLocal<Optional<User>> USER_THREAD_LOCAL = new ThreadLocal<>();

    private LoginUserContext() {
    }

    public static void setLoginUser(User user) {
        USER_THREAD_LOCAL.set(Optional.ofNullable(user));
    }

    public static User getUser() {
        return USER_THREAD_LOCAL.get().orElseThrow(() -> new CommonException(ExceptionEnum.LOGIN_ERROR));
    }

    public static Long getUserId() {
        return USER_THREAD_LOCAL.get().map(User::getId).orElseThrow(() -> new CommonException(ExceptionEnum.LOGIN_ERROR));
    }

    public static void remove() {
        USER_THREAD_LOCAL.remove();
    }
}